unit NDamen99;

interface

uses Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
     StdCtrls, Spin, Grids, ExtCtrls, DBCtrls;

type TNDamen = class(TForm)
      BrettLaenge: TSpinEdit;
      StaticText1: TStaticText;
      Start: TButton;
      StaticTextN: TStaticText;
      LabelN: TLabel;
      StaticTextTime: TStaticText;
      LabelZeit: TLabel;
      CheckAusgabe: TCheckBox;
      Ausgabe: TListBox;
      procedure StartClick(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var NDamen: TNDamen;

implementation

{$R *.DFM}
{$R+,Q+}

 CONST MAX=15;LMax=10000;
 VAR N:BYTE;
     Anzahl:Integer;
     Taste:Char;
     DAME:ARRAY[1..MAX]OF BYTE;
     T_Sek:Extended;
     Liste:Array[1..LMax]of Char;

 function TimeSekunden:Extended;
  var H, M, S, MS : Word;
  begin
   DecodeTime(Now,H,M,S,MS);
   TimeSekunden:=3600.0*H+60.0*M+S+MS/1000
  end;

 PROCEDURE SETZEN;
  BEGIN
         ASM
         PUSHAD                   // alle Registerinhalte auf den Stapel
         MOV EDI,OFFSET DAME      // EDI = Zeiger auf DAME : 1.Element
                                  // im Datenbereich
         MOV ESI,OFFSET Liste     // ESI = Zeiger auf Liste im Datenbereich
         MOV EAX,0                // EAX:=0
         MOVZX ECX,N              // CL wird initialisiert, der Rest von ECX 
                                  // wird mit '0'en gefllt
         MOV EBP,EDI              // EBP:=EDI, Zeiger wird gesichert
         MOV EDX,EDI              // EDX:=EDI, Berechnung des letzten Elementes
         ADD EDX,ECX              // EDX:=EDX+ECX
         DEC EDX                  // EDX:=EDX-1, EDX zeigt auf das letzte
                                  // Element von Dame
@ANFANG: MOV AL,1                 // AL:=1
         MOV [EDI],AL             // D[L]:=1
@OBEN  : MOV EBX,EBP              // K:=1, physikalische Zhlung
@IMINUS: MOV EAX,EDI              // L-1 wird errechnet
         DEC EAX
         CMP EBX,EAX              // K<=L-1
         JBE @LABELA              // falls ja, springe zu @LABELA
         CMP EDI,EDX              // L=N
         JE @TACHO                // falls ja, springe zu @TACHO
         INC EDI                  // L:=L+1
         JMP @ANFANG              // springe zu @ANFANG
@TACHO : INC DWORD PTR[Anzahl]    // A:=A+1
         CMP Taste,'J'            // if Taste='J' then @Ausgabe
         JNE @WEITER              // else @WEITER
         Call @Ausgabe
@WEITER: INC BYTE PTR[EDI]        // D[L]:=D[L]+1
         CMP [EDI],CL             // D[L]<=N ?
         JBE @OBEN                // falls ja, springe zu @OBEN
         DEC EDI                  // L:=L-1
         CMP EDI,EBP              // L=0 ?
         JGE @WEITER              // falls nein, springe zu @WEITER
         JMP @ENDE                // springe zu @ENDE
@LABELA: MOV AL,[EDI]             // D[L]
         MOV AH,[EBX]             // D[K]
         SUB AL,AH                // AL:=D[L]-D[K]
         JZ @WEITER               // falls D[L]-D[K]=0, springe zu @WEITER
         JG @POSITIV              // falls D[L]-D[K]>0, springe zu @POSITIV
         NEG AL                   // AL:=D[K]-D[L]
@POSITIV:AND EAX,255              // EAX wird auf 0 gesetzt, bis auf AL
         ADD EAX,EBX              // AL:=D[K]-D[L]+K in 32-Bitdarstellung
         CMP EAX,EDI              // AL=L ?
         JE @WEITER               // falls ja, springe zu @WEITER
         INC EBX                  // K:=K+1
         JMP @IMINUS              // springe zu @IMINUS
@Ausgabe:PUSH EDI                 // Ausgaberoutine
         PUSH EBX
         PUSH EDX
         PUSH ECX
         MOV BL,65                // BL:='A'
@ZAHL   :MOV [ESI],BL             // LISTE[ESI]:=BL
         INC ESI
         INC BL
         MOV DL,[EDI]             // DL:=D[N]
         ADD DL,48                // Umwandlung in eine Ziffer, '0'<==> ASCII 48
         MOV [ESI],DL
         INC ESI
         DEC EDI                  // N:=N-1
         MOV DL,32                // Leerzeichen ausgeben
         MOV [ESI],DL
         INC ESI
         LOOP @ZAHL               // Zhlschleife
         MOV DL,64                // Trennzeichen fr die einzelnen Stellungen
         MOV [ESI],DL
         INC ESI
         POP ECX
         POP EDX
         POP EBX
         POP EDI
         Ret                       // Return to CALL @AUSGABE+1=@WEITER
@ENDE :  POPAD                     // alle Registerinhalte vom Stapel
         END
  END;

 procedure TNDamen.StartClick(Sender: TObject);
  var Teil:String;
      I:Word;
  begin
   N:=BrettLaenge.Value;Anzahl:=0;Taste:='N';
   if CheckAusgabe.Checked and (N<10) then Taste:='J'
   else CheckAusgabe.Checked:=False;
   FOR I:=1 TO N DO DAME[I]:=0;
   FillChar(Liste,SizeOf(Liste),'@');
   Screen.Cursor:=crHourGlass;
   T_Sek:=TimeSEKUNDEN; SETZEN; T_Sek:=TimeSEKUNDEN-T_Sek;
   Screen.Cursor:=crDefault;
   LabelZeit.Caption:=Format('%0.2f',[T_Sek])+' sek.';
   LabelN.Caption:=IntToStr(Anzahl);
   Teil:='';Ausgabe.Items.Clear;
   if Taste='J' then
    for i:=1 to LMax do
     if Liste[i]<>'@' then Teil:=Teil+Liste[i]
     else
      begin
       if Teil='' then break;
       Ausgabe.Items.Add(Teil);Teil:=''
      end;
  end;

end.

